require'anal'
local boxes = {}

function getRelativePositioning(ax1, ay1, aw, ah, bx1, by1, bw, bh)
  local ax2, ay2, bx2, by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
  local left, right, above, below = ax1 < bx1, ax2 > bx2,  ay1 < by1, ay2 > by2
  local inside = not (left or right or above or below)
  return left, right, above, below, inside 
end

function boxes:draw()
	local i=1
	while self[i] do
		box = self[i]
		love.graphics.rectangle('fill', box.x, box.y, box.width, box.height)
		i = i+1
	end
end

function boxes:boundscheck(x, y, width, height)
	local i=1
	local temp = nil
	while self[i] do
		box = self[i]
		if boundscheck(x, y, width, height, box.x, box.y, box.width, box.height) then
			temp = i
		end
		i = i+1
	end
	return temp
end

function boundscheck(x, y, width, height, boundx, boundy, boundwidth, boundheight)  --function that takes two bounding boxes and checks collision
	if (x < boundx+boundwidth) and (x+width > boundx) and (y < boundy+boundheight) and (y+height > boundy) then
		return true
	else
		return false
	end
end
function love.load()
	boxes[1] = {x = 0, y = 300, width = 480, height = 100}
	
	local reverse= love.graphics.newImage('reverserunning.png')
	local img = love.graphics.newImage('running.png')
	
	jumpmode=true
	upsidemode=false
	portal1={}
	portal1.pic=love.graphics.newImage('portal1.png')
	portal1.x=300
	portal1.y=476
	
	portal2={}
	portal2.pic=love.graphics.newImage('portal2.png')
	portal2.x=500
	portal2.y=476
	
	pinkie={}
	pinkie.x=300
	pinkie.y=476
	pinkie.speed=20
	pinkie.fall=.01
	pinkie.walking=false
	pinkie.jumping=false
	pinkie.right=false
	pinkie.turn=false
	pinkie.fan=false
	pinkie.upside=false
	pinkie.jump=love.graphics.newImage('pinkiejump.png')
	pinkie.pic=love.graphics.newImage('pinkie.png')
	pinkie.upsidejump=love.graphics.newImage('reversejump.png')
	pinkie.upsidepinkie=love.graphics.newImage('reversepinkie.png')
	
	anim=newAnimation(img,106,126,.25,0)
	reverseanim=newAnimation(reverse,106,126,.25,0)
	portal=false
	pie='delicious pie'
	shit=' '
	
	reverseanim=newAnimation(reverse,106,126,.25,0)
	fall=.005
	gamestate=2
end
function love.keypressed(k)
--[[	if k=='q' and upsidemode==true then
		if jumpmode then
			if pinkie.upside and pinkie.jumping then
				pinkie.upside=false
			elseif not pinkie.upside and pinkie.jumping then
				pinkie.upside=true
			end
		end
	end
--]]
	if k==' ' and jumpmode==true then
		if not pinkie.upside then
			pinkie.jumping=true
			pinkie.y=pinkie.y-15
		end
--[[	if pinkie.upside then
			pinkie.jumping=true
			pinkie.y=pinkie.y+15
		end
--]]
	end
	if k=='p' then
		portal=true
	end
end
function love.keyreleased(k)
	if k=='d' then
		pinkie.right=false
		pinkie.walking=false
	end
	if k=='a' then
		pinkie.walking=false
	end
end
function love.update(dt)
	if not pinkie.upside then
		if pinkie.y<476  and boxes:boundscheck(pinkie.x,pinkie.y+pinkie.fall, pinkie.pic:getWidth(), pinkie.pic:getHeight()) == nil then
			pinkie.y=pinkie.y+pinkie.fall
			pinkie.fall=pinkie.fall+.0015
		end
		if pinkie.y>=476 then
			pinkie.jumping=false
			pinkie.fall=.01
		end
		if pinkie.y<450 then
			pinkie.jumping=false
		end
	end
	if pinkie.upside then
		if pinkie.y>0 and boxes:boundscheck(pinkie.x,pinkie.y+fall, pinkie.pic:getWidth(), pinkie.pic:getHeight()) == nil then	
			pinkie.y=pinkie.y+pinkie.fall
			pinkie.fall=pinkie.fall-.0015
		end
		if pinkie.y<=0 then
			pinkie.jumping=false
			pinkie.fall=.01
		end
	end	
	if love.keyboard.isDown('a')  and pinkie.right==false and boxes:boundscheck(pinkie.x-.075,pinkie.y, pinkie.pic:getWidth(), pinkie.pic:getHeight()) == nil then
		pinkie.turn=true
		pinkie.walking=true
		pinkie.x=pinkie.x-.075
		if pinkie.jumping then
			pinkie.x=pinkie.x-1.5*(pinkie.speed*dt)
		end
		if love.keyboard.isDown('lshift') then
			pinkie.x=pinkie.x-.15
		end
	elseif love.keyboard.isDown('d') and boxes:boundscheck(pinkie.x+.075,pinkie.y, pinkie.pic:getWidth(), pinkie.pic:getHeight()) == nil  then
		pinkie.right=true
		pinkie.walking=true
		pinkie.turn=false
		pinkie.x=pinkie.x+.075
		if jumping then
			pinkie.x=pinkie.x+1.5*(pinkie.speed*dt)
		end
		if love.keyboard.isDown('lshift') then
			pinkie.x=pinkie.x+.15
		end
	end
	if portal==true then
		if pinkie.x>=(portal1.x-50) and pinkie.x<=(portal1.x+10) and pinkie.y>=(portal1.y-50) and  pinkie.y<=(portal1.y+50) then
			pinkie.y=portal2.y
			if pinkie.turn then
				pinkie.x=portal2.x-51
			else
				pinkie.x=portal2.x+11
			end
		end
		if pinkie.x>=(portal2.x-50) and pinkie.x<=(portal2.x+10) and pinkie.y>=(portal2.y-50) and  pinkie.y<=(portal2.y+50) then
			pinkie.y=portal1.y
			if pinkie.turn then
				pinkie.x=portal1.x-51
			else
				pinkie.x=portal1.x+11
			end
		end
		if love.keyboard.isDown('1') then
			if love.keyboard.isDown('up')and boxes:boundscheck(portal1.x, portal1.y-1, portal1.pic:getWidth(), portal1.pic:getHeight()) == nil then
				portal1.y=portal1.y-1
			elseif love.keyboard.isDown('down')and boxes:boundscheck(portal1.x,portal1.y+1, portal1.pic:getWidth(), portal1.pic:getHeight()) == nil then
				portal1.y=portal1.y+1
			end
			if love.keyboard.isDown('left') and boxes:boundscheck(portal1.x-1,portal1.y, portal1.pic:getWidth(), portal1.pic:getHeight()) == nil then
				portal1.x=portal1.x-1
			elseif love.keyboard.isDown('right')and boxes:boundscheck(portal1.x+1,portal1.y, portal1.pic:getWidth(), portal1.pic:getHeight()) == nil  then
				portal1.x=portal1.x+1
			end
		end
		if love.keyboard.isDown('2') then
			if love.keyboard.isDown('up')and boxes:boundscheck(portal2.x, portal2.y-1, portal2.pic:getWidth(), portal2.pic:getHeight()) == nil then
				portal2.y=portal2.y-1
			elseif love.keyboard.isDown('down')and boxes:boundscheck(portal2.x,portal2.y+1, portal2.pic:getWidth(), portal2.pic:getHeight()) == nil then
				portal2.y=portal2.y+1
			end
			if love.keyboard.isDown('left') and boxes:boundscheck(portal2.x-1,portal2.y, portal2.pic:getWidth(), portal2.pic:getHeight()) == nil then
				portal2.x=portal2.x-1
			elseif love.keyboard.isDown('right')and boxes:boundscheck(portal2.x+1,portal2.y, portal2.pic:getWidth(), portal2.pic:getHeight()) == nil  then
				portal2.x=portal2.x+1
			end
		end
	end
	anim:update(dt)
	reverseanim:update(dt)
end
function love.draw()
	if not pinkie.upside then
		if pinkie.walking then
			if pinkie.turn then	
				anim:draw(pinkie.x +124, pinkie.y, 0,-1,1,0,0)
			else
				anim:draw(pinkie.x,pinkie.y)
			end
		end
		if pinkie.jumping then
			if pinkie.turn then
				love.graphics.draw(pinkie.jump,pinkie.x +124, pinkie.y, 0,-1,1,0,0)
			else
				love.graphics.draw(pinkie.jump,pinkie.x,pinkie.y)
			end
		end
		if not pinkie.walking and not pinkie.jumping then
			if pinkie.turn then
				love.graphics.draw(pinkie.pic,pinkie.x +124, pinkie.y, 0,-1,1,0,0)
			else
				love.graphics.draw(pinkie.pic,pinkie.x,pinkie.y)
			end
		end
	end
--[[	if pinkie.upside then
		if pinkie.walking then
			if pinkie.turn then
				reverseanim:draw(pinkie.x+124,pinkie.y,0,-1,1,0,0)
			else
				reverseanim:draw(pinkie.x,pinkie.y)
			end
		end
		if pinkie.jumping then
			if pinkie.turn then
				love.graphics.draw(upsidejump,pinkie.x+124,y,0,-1,1,0,0)
			else
				love.graphics.draw(pinkie.upsidejump,pinkie.x,pinkie.y)
			end
		end
		if not pinkie.walking and not pinkie.jumping then
			if pinkie.turn then
				love.graphics.draw(pinkie.upsidepinkie,pinkie.x+124,pinkie.y,0,-1,1,0,0)
			else
				love.graphics.draw(pinkie.upsidepinkie,pinkie.x,pinkie.y)
			end
		end
	end
--]]
	if portal==true then
		love.graphics.draw(portal1.pic,portal1.x,portal1.y)
		love.graphics.draw(portal2.pic,portal2.x,portal2.y)
	end
	boxes:draw();
end